#include "fintrf.h"
C=============================================
C PARSER to convert a MATLAB sparse band matrix 
C to band storage required by LAPACK/SBR
C=============================================
      subroutine AtoAB(n, lda, a, ir, jc, ab, b)

      implicit none

      mwIndex ir(*), jc(*)
      INTEGER*8 lda, b
      DOUBLE PRECISION a(*), ab(lda, *)
      INTEGER*8 i, j, k, ix
      INTEGER*8 n, nzmax, kmin, kmax

      DO i=1,lda
        DO j=1,N
            ab(i,j) = 0.0D0
        END DO
      END DO

      nzmax = jc(n+1)

C     sparse indexing is zero-based
      DO j=1,N
        kmin = jc(j) + 1
        kmax = jc(j+1)
        DO k=kmin,kmax
           IF ( ir(k) + 1 .GE. j) THEN
              ix = 1 + ir(k) + 1 - j
              ab(ix,j) = a(k)
C              write(*,*) k, ix, j
           END IF
        END DO
      END DO

      return

      end